﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private CustomListView1 As CustomListView
	Private currentIndex As Int
	Private touchPanel As Panel
	Private startPointX As Float
	Private frameWidth, frameHeight, reduction, reduc As Float
	Private partHiddenPanel As B4XView
	Private B4XImageView1 As B4XImageView
End Sub

Public Sub Initialize
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.Color = xui.Color_white
	partHiddenPanel = xui.CreatePanel("")
	
	If GetDeviceLayoutValues.Width < GetDeviceLayoutValues.Height Then
		frameWidth = .667 * Root.width
		Else
		frameWidth = .667 * Root.Height
	End If
	
	
	frameHeight = 3 * frameWidth / 2		'aspect raetio
	reduction = .85							'smaller size scale factor
	reduc = .5 * (1 - reduction)
	
	Root.AddView(partHiddenPanel, - .75 * frameWidth, Root.height / 2 - frameHeight/ 2, 2.5 * frameWidth, frameHeight)
	partHiddenPanel.LoadLayout("MainPage")	'the sides of this wider/flatter panel are outside the screen area - the CLV will fill it
	partHiddenPanel.Color=Colors.red
	Sleep(10)

	Dim touchPanel As Panel
	touchPanel.Initialize("touchpnl")
	
'	If GetDeviceLayoutValues.Width < GetDeviceLayoutValues.Height Then
	Root.AddView(touchPanel, 0, 0, Root.Width, Root.Height)
'	Else
'		
'		Root.AddView(touchPanel, 0, 0, Root.Height, Root.Width)
'	End If
	
	For i = 0 To 8
		Dim framePanel As B4XView = xui.CreatePanel("armut")
		framePanel.SetColorAndBorder(xui.Color_White, 0, 0, 0)
		framePanel.SetLayoutAnimated(0, 0, 0, frameWidth, frameHeight)
		CustomListView1.Add(framePanel, i)
		If i = 1 Then
			framePanel.loadLayout("image")
			Sleep(10)
			B4XImageView1.Load(File.DirAssets, "hummingbird.jpg")
		Else
			Dim lbl As Label: lbl.Initialize("")
			Dim lblx As B4XView = lbl
			lblx.SetTextAlignment("CENTER", "CENTER")
			lblx.SetColorAndBorder(xui.Color_RGb(220, 220, 255), 1dip, xui.color_black, 0)
			If i = 0 Or i = 8 Then lblx.Text = "DUMMY" Else lblx.Text = "XXXX " & i					'first and last panel are dummies
			framePanel.AddView(lblx, reduc * frameWidth, reduc * frameHeight, reduction * frameWidth, reduction * frameHeight)	'all frames are loaded at smaller size
		End If
	Next
	Sleep(10)
	currentIndex = 1
	Dim pnl As B4XView = CustomListView1.GetPanel(currentIndex)
	Dim lblx As B4XView = pnl.GetView(0)
	lblx.SetLayoutAnimated(0, 0, 0, frameWidth, frameHeight)
End Sub
Sub armut_Click
	Msgbox ("Armut","")
End Sub
Sub touchpnl_Touch(Action As Int, X As Float, Y As Float)
	Select Action
	
		Case touchPanel.ACTION_DOWN
			startPointX = X
		Case touchPanel.ACTION_MOVE
		Case touchPanel.ACTION_UP
			If X > startPointX Then
				If currentIndex > 1 Then animateToRight Else currentIndex = currentIndex + 1
				currentIndex = currentIndex - 1
			Else If X < startPointX Then
				currentIndex = currentIndex + 1
				If currentIndex < CustomListView1.size - 1 Then animateToLeft Else currentIndex = currentIndex - 1
			End If
	End Select
	Sleep(10)
End Sub

private Sub animateToLeft
	Dim startLblx As B4XView = CustomListView1.GetPanel(currentIndex - 1).GetView(0)
	Dim targetlblx As B4XView = CustomListView1.GetPanel(currentIndex).GetView(0)
	Dim reductionStep As Float = (1 - reduction ) / 15
	Dim reductionDelta As Float = reductionStep / 40
	Dim Reduction1 As Float = 1
	Dim Reduction2 As Float = reduction
	Dim reduc1, reduc2 As Float
	
	Dim startOffset As Int = CustomListView1.sv.ScrollViewOffsetX
	Dim targetOffset As Int =  startOffset + frameWidth
	Dim stepSize As Float = (targetOffset - startOffset) / 15
	Dim delta As Float = stepSize / 40
	Do While startOffset < targetOffset
		startOffset = startOffset + stepSize
		If startOffset > targetOffset Then Exit
		CustomListView1.sv.ScrollViewOffsetX = startOffset
		Reduction1 = Max(.85, Reduction1 - reductionStep): reduc1 = .5 * (1 - Reduction1)
		Reduction2 = Min(1, Reduction2 + reductionStep): reduc2 = .5 * (1 - Reduction2)
		startLblx.SetLayoutAnimated(0, reduc1 * frameWidth, reduc1 * frameHeight, Reduction1 * frameWidth, Reduction1 * frameHeight)
		targetlblx.SetLayoutAnimated(0, reduc2 * frameWidth, reduc2 * frameHeight, Reduction2 * frameWidth, Reduction2 * frameHeight)
		Sleep(15)
		stepSize = Max(1dip, stepSize - delta)
		reductionStep = Max(0, reductionStep - reductionDelta)
	Loop
	startLblx.SetLayoutAnimated(0, reduc * frameWidth, reduc * frameHeight, reduction * frameWidth, reduction * frameHeight)
	targetlblx.SetLayoutAnimated(0, 0, 0, frameWidth, frameHeight)
	CustomListView1.sv.ScrollViewOffsetX = targetOffset
End Sub

private Sub animateToRight
	Dim startLblx As B4XView = CustomListView1.GetPanel(currentIndex).GetView(0)
	Dim targetlblx As B4XView = CustomListView1.GetPanel(currentIndex - 1).GetView(0)
	Dim reductionStep As Float = (1 - reduction ) / 15
	Dim reductionDelta As Float = reductionStep / 40
	Dim Reduction1 As Float = 1
	Dim Reduction2 As Float = reduction
	Dim reduc1, reduc2 As Float

	Dim startOffset As Int = CustomListView1.sv.ScrollViewOffsetX
	Dim targetOffset As Int =  startOffset - frameWidth
	Dim stepSize As Float = (targetOffset - startOffset) / 15
	Dim delta As Float = stepSize / 40
	Do While startOffset > targetOffset
		startOffset = startOffset + stepSize
		If startOffset < targetOffset Then Exit
		CustomListView1.sv.ScrollViewOffsetX = startOffset
		Reduction1 = Max(.85, Reduction1 - reductionStep): reduc1 = .5 * (1 - Reduction1)
		Reduction2 = Min(1, Reduction2 + reductionStep): reduc2 = .5 * (1 - Reduction2)
		startLblx.SetLayoutAnimated(0, reduc1 * frameWidth, reduc1 * frameHeight, Reduction1 * frameWidth, Reduction1 * frameHeight)
		targetlblx.SetLayoutAnimated(0, reduc2 * frameWidth, reduc2 * frameHeight, Reduction2 * frameWidth, Reduction2 * frameHeight)
		Sleep(15)
		stepSize = Min(-1dip, stepSize - delta)
		reductionStep = Max(0, reductionStep - reductionDelta)
	Loop
	startLblx.SetLayoutAnimated(0, reduc * frameWidth, reduc * frameHeight, reduction * frameWidth, reduction * frameHeight)
	targetlblx.SetLayoutAnimated(0, 0, 0, frameWidth, frameHeight)
	CustomListView1.sv.ScrollViewOffsetX = targetOffset
End Sub
